﻿using System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;

namespace Demo.Converters
{
    /// <summary>
    /// Converts a Boolean into a Visibility with reverse feature.
    /// </summary>
    public sealed class BooleanToVisibilityConverter : IValueConverter
    {
        /// <summary>
        /// If set to True, conversion is reversed: True will become Collapsed.
        /// </summary>
        public bool IsReversed { get; set; }

        public object Convert(object value, Type targetType, object parameter, string language)
        {
            var val = System.Convert.ToBoolean(value);
            IsReversed = System.Convert.ToBoolean(parameter as string);

            if (IsReversed)
                val = !val;

            return !val ? Visibility.Visible : Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}
