﻿using System;
using System.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;

namespace Demo.Converters
{
    /// <summary>
    /// Converts a Boolean into a Visibility with reverse feature.
    /// </summary>
public sealed class ListEmptyToVisibilityConverter : IValueConverter
{
    /// <summary>
    /// If set to True, conversion is reversed: True will become Collapsed.
    /// </summary>
    public bool IsReversed { get; set; }

    public object Convert(object value, Type targetType, object parameter, string language)
    {
        IsReversed = System.Convert.ToBoolean(parameter as string);

        if (value is IList)
        {
            var result = value as IList;
            var test = result.Count != 0;
            if (IsReversed)
            {
                test = !test;
            }
            return test ? Visibility.Visible : Visibility.Collapsed;
        }

        return Visibility.Collapsed;
    }

    public object ConvertBack(object value, Type targetType, object parameter, string language)
    {
        throw new NotImplementedException();
    }
}
}