﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace Demo.Extensions
{
    public static class EnumerableExtensions
    {
        /// <summary>
        /// Random shuffle of a IList
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="list"></param>
        public static void Shuffle<T>(this IList<T> list)
        {
            var rng = new Random();
            var n = list.Count;
            while (n > 1)
            {
                n--;
                var k = rng.Next(n + 1);
                var value = list[k];
                list[k] = list[n];
                list[n] = value;
            }
        }
    }
}
