﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;
using Demo.ViewModels.Items;

namespace Demo.ViewModels
{
    public class BookPageVm : VmBase
    {
        public BookPageVm()
        {
            if (DesignMode)
            {
                SampleData();
            }
        }

        public List<BookVmi> Books { get; set; }
        public BookVmi SelectedBook { get; set; }

        private void SampleData()
        {
            var books = new List<BookVmi>
                {
                    new BookVmi
                        {
                            Title = "The Colour of Magic",
                            Cover = "/images/TCoM_cover.jpg",
                            Serie = "Rincewind",
                            Year = "1983",
                            Description =
                                "The Colour of Magic is a 1983 comic fantasy novel by Terry Pratchett, and is the first book of the Discworld series."
                        },
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "The Light Fantastic"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "The Light Fantastic"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "The Light Fantastic"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "The Light Fantastic"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"}
                };
            Books = new List<BookVmi>(books);

            SelectedBook = Books[0];
        }


        public async Task Init(BookVmi book = null)
        {
            var generator = new BookGenerator();
            Books = generator.CreateDiscWorldCollection();

            if (book != null)
            {
                foreach (var b in Books.Where(b => book.Title == b.Title))
                {
                    SelectedBook = b;
                    break;
                }
            }
        }
    }
}