﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;
using Demo.Extensions;
using Demo.ViewModels.Items;

namespace Demo.ViewModels
{
    public class StartPageVm : VmBase
    {
        public ObservableCollection<BookVmi> FeaturedBooks { get; set; }

        public StartPageVm()
        {
            if (DesignMode)
            {
                SampleData();
            }
        }

        private void SampleData()
        {
            var books = new List<BookVmi>
                {
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "The Light Fantastic"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"},
                    new BookVmi {Cover = "/images/185px-Carpe-jugulum-1.jpg", Title = "Lorem Ipsum"}
                };
            FeaturedBooks = new ObservableCollection<BookVmi>(books);
        }

        public async Task Init()
        {
            // Get three random books to show as "featured books"
            var generator = new BookGenerator();
            var books = generator.CreateDiscWorldCollection();
            books.Shuffle();
            var randomList = (books.Select(b => b)).Take(3);
            FeaturedBooks = new ObservableCollection<BookVmi>(randomList);
        }
    }
}