﻿using System;
using System.Collections.Generic;
using Demo.Common;
using Demo.ViewModels;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Input;

namespace Demo.Views
{
    public sealed partial class StartPage
    {
        private readonly StartPageVm _vm;

        public StartPage()
        {
            InitializeComponent();
            _vm = (StartPageVm) DataContext;
        }

        /// <summary>
        ///     Populates the page with content passed during navigation.  Any saved state is also
        ///     provided when recreating a page from a prior session.
        /// </summary>
        /// <param name="navigationParameter">
        ///     The parameter value passed to
        ///     <see cref="Frame.Navigate(Type, Object)" /> when this page was initially requested.
        /// </param>
        /// <param name="pageState">
        ///     A dictionary of state preserved by this page during an earlier
        ///     session.  This will be null the first time a page is visited.
        /// </param>
        protected override async void LoadState(Object navigationParameter, Dictionary<String, Object> pageState)
        {
            await _vm.Init();
        }

        /// <summary>
        ///     Preserves state associated with this page in case the application is suspended or the
        ///     page is discarded from the navigation cache.  Values must conform to the serialization
        ///     requirements of <see cref="SuspensionManager.SessionState" />.
        /// </summary>
        /// <param name="pageState">An empty dictionary to be populated with serializable state.</param>
        protected override void SaveState(Dictionary<String, Object> pageState)
        {
        }

        private void ShowAllBooksTapped(object sender, TappedRoutedEventArgs e)
        {
            Frame.Navigate(typeof (BookPage));
        }

        private void FeaturedBookSelected(object sender, Windows.UI.Xaml.Controls.SelectionChangedEventArgs e)
        {
            if (FeaturedBooksListBox.SelectedItem!=null)
                Frame.Navigate(typeof(BookPage), FeaturedBooksListBox.SelectedItem);
        }


    }
}